from main_object import *
from game_global_object import *
from user_input_object import *
from weight_create import *
import time

class game_status(game_object):
  ui = user_input()
  history = []
  game_over = 0
  right_list_string = ""
  left_list_string = ""
  non_list_string = ""
  def set_user_input(self, raw):
    self.ui.parser_input_cmd(raw)
    if self.ui.error_msg:
      self.status = self.ui.error_msg
    else:  
      if self.ui.cmd in 'rln':
        for n in self.ui.sub_cmd:
          for b in self.game_global.blocks_sides:
            if b.name == n:
              if self.ui.cmd == 'r':
                b.side = "right"
              elif self.ui.cmd == 'l':
                b.side = "left"
              elif self.ui.cmd == 'n':
                b.side = "non"
  #      self.game_global.blocks_sides.count_weight()
        self.get_status()
      elif self.ui.cmd == "h":
        self.status = ''
        for l in self.history:
          self.status += l + "\n"
      elif self.ui.cmd == "t":
        self.status = "Now: %s" %self.game_global.timer.end_time
      elif self.ui.cmd == "q":
        self.status = "QUIT"

  def get_status(self):
    self.game_global.blocks_sides.count_weight()
    if self.game_global.blocks_sides.isPass():
      self.status = "PASS"
      self.history = []
    else:
      if len(self.history) < 100:
        self.status = "H:%s %s:%s %s %s %s P:%s T:%s" %(
          len(self.history),
          self.game_global.wl.left_items,
          self.game_global.blocks_sides.side_string["left"],
          self.game_global.blocks_sides.balance_string,
          self.game_global.blocks_sides.side_string["right"],
          self.game_global.blocks_sides.side_string["non"],
          self.game_global.question_pass,
          self.game_global.timer.end_time )
        self.history.append(self.status)   
      else:
        self.status = "Game Over: Too long history."
        self.game_over = 1

if __name__ == "__main__":
  my_game = game_global()
  my_game.timer.start()
  gs = game_status()
  gs.set_global(my_game)
  my_game.wl.set_left(3)
  my_game.blocks_sides.set_global(my_game)
  my_game.wl.gen()
  for i in range(0,len(my_game.wl.full_list)):
    my_game.blocks_sides[i].weight = my_game.wl.full_list[i]
  gs.get_status()
  print gs.status
#  time.sleep(2)
  gs.set_user_input('r:abc')
#  time.sleep(3)

  gs.set_user_input('l:beg')
#  gs.get_status()
  gs.set_user_input('n:ae')
#  gs.get_status()
  gs.set_user_input('r:ef')
#  gs.get_status()
  gs.set_user_input('l:dg')
#  gs.get_status()
  gs.set_user_input('n:cb')
#  gs.get_status()
  gs.set_user_input('r:f')
#  gs.get_status()
  gs.set_user_input('l:ad')
#  gs.get_status()

  gs.set_user_input('l:beg')
#  gs.get_status()
  gs.set_user_input('n:ae')
#  gs.get_status()
  gs.set_user_input('r:ef')
#  gs.get_status()
  gs.set_user_input('l:dg')
#  gs.get_status()
  gs.set_user_input('n:cb')
#  gs.get_status()
  gs.set_user_input('r:f')
#  gs.get_status()
  gs.set_user_input('l:ad')
#  gs.get_status()
  gs.set_user_input('l:beg')
#  gs.get_status()
  gs.set_user_input('n:ae')
#  gs.get_status()
  gs.set_user_input('r:ef')
#  gs.get_status()
  gs.set_user_input('l:dg')
#  gs.get_status()
  gs.set_user_input('n:cb')
#  gs.get_status()
  gs.set_user_input('r:f')
#  gs.get_status()
  gs.set_user_input('l:ad')
#  gs.get_status()
  gs.set_user_input('l;ad')
  print gs.status
  time.sleep(2)
  print 'Print History now.'
  gs.set_user_input('h:')
  print gs.status
  gs.set_user_input('t:')
  print gs.status
  my_game.timer.the_end = 1
